-- DejaBars

local _, private = ...
	private.defaults.petSetPoints = {
		point = "BOTTOMLEFT", 
		relativeTo = "MultiBarBottomRightButton1", 
		relativePoint = "TOPLEFT", 
		xOffset = 0, 
		yOffset = 6,
	}	
	private.defaults.stanceSetPoints = {
		point = "BOTTOMLEFT", 
		relativeTo = "MultiBarBottomRightButton1", 
		relativePoint = "TOPLEFT", 
		xOffset = 0, 
		yOffset = 44,
	}
	private.defaults.rightsidebarsSetPoints = {
		point = "BOTTOMRIGHT", 
		relativeTo = "Minimap", 
		relativePoint = "BOTTOMLEFT", 
		xOffset = 0, 
		yOffset = 0,
	}
	private.defaults.micromenuSetPoints = {
		point = "BOTTOMRIGHT", 
		relativeTo = "Minimap", 
		relativePoint = "TOPRIGHT", 
		xOffset = 0, 
		yOffset = 0,
	}
	private.defaults.bagsSetPoints = {
		point = "BOTTOMRIGHT", 
		relativeTo = "dvrsbframe", 
		relativePoint = "BOTTOMLEFT", 
		xOffset = 0, 
		yOffset = 0,
	}

-- Main Menu Bars

--Hide Main Bar Art
		MainMenuBarLeftEndCap:Hide()
		MainMenuBarRightEndCap:Hide()

		MainMenuBarTexture0:Hide()
		MainMenuBarTexture1:Hide()
		MainMenuBarTexture2:Hide()
		MainMenuBarTexture3:Hide()	
		
		MainMenuMaxLevelBar0:Hide()
		MainMenuMaxLevelBar1:Hide()
		MainMenuMaxLevelBar2:Hide()
		MainMenuMaxLevelBar3:Hide()

		StanceBarLeft:SetAlpha(0)
		StanceBarMiddle:SetAlpha(0)
		StanceBarRight:SetAlpha(0)

		SlidingActionBarTexture0:SetAlpha(0)
		SlidingActionBarTexture1:SetAlpha(0)	 
		
		ExhaustionLevelFillBar:Hide()
		MainMenuXPBarTextureLeftCap:Hide()
		MainMenuXPBarTextureRightCap:Hide()
		MainMenuXPBarTextureMid:Hide()
		
		MainMenuBarMaxLevelBar:Hide()

		MainMenuMaxLevelBar0:Hide()
		MainMenuMaxLevelBar1:Hide()
		MainMenuMaxLevelBar2:Hide()
		MainMenuMaxLevelBar3:Hide()
		
		ReputationWatchBar.StatusBar.WatchBarTexture0:SetAlpha(0);
		ReputationWatchBar.StatusBar.WatchBarTexture1:SetAlpha(0);
		ReputationWatchBar.StatusBar.WatchBarTexture2:SetAlpha(0);
		ReputationWatchBar.StatusBar.WatchBarTexture3:SetAlpha(0);
		
		ArtifactWatchBar.StatusBar.WatchBarTexture0:SetAlpha(0);
		ArtifactWatchBar.StatusBar.WatchBarTexture1:SetAlpha(0);
		ArtifactWatchBar.StatusBar.WatchBarTexture2:SetAlpha(0);
		ArtifactWatchBar.StatusBar.WatchBarTexture3:SetAlpha(0);
		
		ArtifactWatchBar.StatusBar.XPBarTexture0:SetAlpha(0);
		ArtifactWatchBar.StatusBar.XPBarTexture1:SetAlpha(0);
		ArtifactWatchBar.StatusBar.XPBarTexture2:SetAlpha(0);
		ArtifactWatchBar.StatusBar.XPBarTexture3:SetAlpha(0);
		
		CastingBarFrame.Border:SetTexture(nil);
		CastingBarFrame.Flash:SetTexture(nil);
		CastingBarFrame.Icon:Show();
		CastingBarFrame.Text:ClearAllPoints();	
		CastingBarFrame.Text:SetPoint("CENTER",CastingBarFrame,"CENTER",0,0);
		
		TargetFrameSpellBar.Border:SetTexture(nil);
		TargetFrameSpellBar.Flash:SetTexture(nil);
		TargetFrameSpellBar.Icon:Show();
		TargetFrameSpellBar.Text:ClearAllPoints();	
		TargetFrameSpellBar.Text:SetPoint("CENTER",TargetFrameSpellBar,"CENTER",0,0);
		
		FocusFrameSpellBar.Border:SetTexture(nil);
		FocusFrameSpellBar.Flash:SetTexture(nil);
		FocusFrameSpellBar.Icon:Show();
		FocusFrameSpellBar.Text:ClearAllPoints();	
		FocusFrameSpellBar.Text:SetPoint("CENTER",FocusFrameSpellBar,"CENTER",0,0);
		
--Castbar timer from thek
cbf = "CastingBarFrame"
tbf = "TargetFrameSpellBar"
fbf = "FocusFrameSpellBar"

_G[cbf].timer = _G[cbf]:CreateFontString(nil)
_G[cbf].timer:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
_G[cbf].timer:SetPoint("RIGHT", _G[cbf], "RIGHT", 24, 0)
_G[cbf].update = .1
_G[tbf].timer = _G[tbf]:CreateFontString(nil)
_G[tbf].timer:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
_G[tbf].timer:SetPoint("RIGHT", _G[tbf], "RIGHT", 24, 0)
_G[tbf].update = .1
_G[fbf].timer = _G[fbf]:CreateFontString(nil)
_G[fbf].timer:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
_G[fbf].timer:SetPoint("RIGHT", _G[fbf], "RIGHT", 24, 0)
_G[fbf].update = .1
hooksecurefunc("CastingBarFrame_OnUpdate", function(self, elapsed)
	if not self.timer then return end
	if self.update and self.update < elapsed then
		if self.casting then
			self.timer:SetText(format("%.1f", max(self.maxValue - self.value, 0)))
		elseif self.channeling then
			self.timer:SetText(format("%.1f", max(self.value, 0)))
		else
			self.timer:SetText("")
		end
		self.update = .1
	else
		self.update = self.update - elapsed
	end
end)


	 
--Hide XP Bar Art
	for i = 1, 19 do
		local texture = _G["MainMenuXPBarDiv"..i]
			if texture then
				texture:SetAlpha(0)
		end
	end
	
-- DVMainBarFrame to center the main bar on
local mbars=CreateFrame("Frame", "mbars", dvlockcheckframe)
	mbars:SetClampedToScreen(true)
	mbars:SetPoint("BOTTOM", dvlockcheckframe, "BOTTOM")
	mbars:SetSize(476,36)

-- DVPetFrame
local dvpetframe = CreateFrame("Frame", "DejaViewPetFrame", dvlockcheckframe)
	-- you can't place the frame yet since your saved settings haven't loaded yet
	dvpetframe:RegisterEvent("PLAYER_LOGIN")
	dvpetframe:SetFrameStrata("HIGH")
	dvpetframe:SetClampedToScreen(true)
	dvpetframe:SetMovable(true)
	dvpetframe:EnableMouse(true)
	dvpetframe:RegisterForDrag("LeftButton")
	dvpetframe:SetWidth(318)
	dvpetframe:SetHeight(38)
	dvpetframe:Show()

	dvpetframe:SetScript("OnEvent", function(self, event, arg1)
		if event == "PLAYER_LOGIN" then
		local point = private.db.petSetPoints
			self:ClearAllPoints()		
			self:SetPoint(
				point.point, 
				point.relativeTo, 
				point.relativePoint, 
				point.xOffset, 
				point.yOffset)
		end
	end)
	
	dvpetframe:SetScript("OnDragStart", dvpetframe.StartMoving) 
	
	dvpetframe:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing() 
		self:SetUserPlaced(false) 
		
		point, relativeTo, relativePoint, xOfs, yOfs = self:GetPoint(1)
			if ( relativeTo ) then
				relativeTo = relativeTo:GetName();
			else
				relativeTo = self:GetParent():GetName();
			end
	
		-- These are debugging messages for the frame points
		-- Un-comment them to help debug
		-- DEFAULT_CHAT_FRAME:AddMessage(point)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativeTo)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativePoint)
		-- DEFAULT_CHAT_FRAME:AddMessage(xOfs)
		-- DEFAULT_CHAT_FRAME:AddMessage(yOfs)
		
		private.db.petSetPoints.point = point
		private.db.petSetPoints.relativeTo = relativeTo
		private.db.petSetPoints.relativePoint = relativePoint
		private.db.petSetPoints.xOffset = xOfs
		private.db.petSetPoints.yOffset = yOfs		
	end)
	
local dvpetframeFS = dvpetframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local dvpetFS = dvpetframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	dvpetFS:SetPoint("CENTER",dvpetframe,"CENTER",0,0)
	dvpetFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
	dvpetFS:SetText("Pet Action Bar");
	dvpetFS:SetTextColor(1, 1, 1);
	
	local t=dvpetframe:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(dvpetframe)
	t:SetColorTexture(0, 192, 255, 0.7)
	
-- DVStanceFrame
local dvstanceframe=CreateFrame("Frame", "dvstanceframe", dvlockcheckframe)
	dvstanceframe:RegisterEvent("PLAYER_LOGIN")
	dvstanceframe:SetFrameStrata("HIGH")
	dvstanceframe:SetClampedToScreen(true)
	dvstanceframe:SetMovable(true)
	dvstanceframe:EnableMouse(true)
	dvstanceframe:RegisterForDrag("LeftButton")
	dvstanceframe:SetWidth(190)
	dvstanceframe:SetHeight(38)
	dvstanceframe:Show()
	
	dvstanceframe:SetScript("OnEvent", function(self, event, arg1)
		if event == "PLAYER_LOGIN" then
		local point = private.db.stanceSetPoints
			self:ClearAllPoints()		
			self:SetPoint(
				point.point, 
				point.relativeTo, 
				point.relativePoint, 
				point.xOffset, 
				point.yOffset)
		end
	end)
	
	dvstanceframe:SetScript("OnDragStart", dvstanceframe.StartMoving) 
	
	dvstanceframe:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing() 
		self:SetUserPlaced(false) 
		
		point, relativeTo, relativePoint, xOfs, yOfs = self:GetPoint(1)
			if ( relativeTo ) then
				relativeTo = relativeTo:GetName();
			else
				relativeTo = self:GetParent():GetName();
			end
	
		-- These are debugging messages for the frame points
		-- Un-comment them to help debug
		-- DEFAULT_CHAT_FRAME:AddMessage(point)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativeTo)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativePoint)
		-- DEFAULT_CHAT_FRAME:AddMessage(xOfs)
		-- DEFAULT_CHAT_FRAME:AddMessage(yOfs)
		
		private.db.stanceSetPoints.point = point
		private.db.stanceSetPoints.relativeTo = relativeTo
		private.db.stanceSetPoints.relativePoint = relativePoint
		private.db.stanceSetPoints.xOffset = xOfs
		private.db.stanceSetPoints.yOffset = yOfs		
	end)

local dvstanceframeFS = dvstanceframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local dvstanceFS = dvstanceframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	dvstanceFS:SetPoint("CENTER",dvstanceframe,"CENTER",0,0)
	dvstanceFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
	dvstanceFS:SetText("Stance Action Bar");
	dvstanceFS:SetTextColor(1, 1, 1);
	
	local t=dvstanceframe:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(dvstanceframe)
	t:SetColorTexture(0, 192, 255, 0.7)
	
-- DVRightSideBarsFrame
local dvrsbframe=CreateFrame("Frame", "dvrsbframe", dvlockcheckframe)
	dvrsbframe:RegisterEvent("PLAYER_LOGIN")
	dvrsbframe:SetFrameStrata("HIGH")
	dvrsbframe:SetClampedToScreen(true)
	dvrsbframe:SetMovable(true)
	dvrsbframe:EnableMouse(true)
	dvrsbframe:RegisterForDrag("LeftButton")
	dvrsbframe:SetWidth(191)
	dvrsbframe:SetHeight(121)
	dvrsbframe:Show()
	
	dvrsbframe:SetScript("OnEvent", function(self, event, arg1)
		if event == "PLAYER_LOGIN" then
		local point = private.db.rightsidebarsSetPoints
			self:ClearAllPoints()		
			self:SetPoint(
				point.point, 
				point.relativeTo, 
				point.relativePoint, 
				point.xOffset, 
				point.yOffset)
		end
	end)
	
	dvrsbframe:SetScript("OnDragStart", dvrsbframe.StartMoving) 
	
	dvrsbframe:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing() 
		self:SetUserPlaced(false) 
		
		point, relativeTo, relativePoint, xOfs, yOfs = self:GetPoint(1)
			if ( relativeTo ) then
				relativeTo = relativeTo:GetName();
			else
				relativeTo = self:GetParent():GetName();
			end
	
		-- These are debugging messages for the frame points
		-- Un-comment them to help debug
		-- DEFAULT_CHAT_FRAME:AddMessage(point)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativeTo)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativePoint)
		-- DEFAULT_CHAT_FRAME:AddMessage(xOfs)
		-- DEFAULT_CHAT_FRAME:AddMessage(yOfs)
		
		private.db.rightsidebarsSetPoints.point = point
		private.db.rightsidebarsSetPoints.relativeTo = relativeTo
		private.db.rightsidebarsSetPoints.relativePoint = relativePoint
		private.db.rightsidebarsSetPoints.xOffset = xOfs
		private.db.rightsidebarsSetPoints.yOffset = yOfs		
	end)
	
local dvrsbframeFS = dvrsbframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local dvrsbFS = dvrsbframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	dvrsbFS:SetPoint("CENTER",dvrsbframe,"CENTER",0,0)
	dvrsbFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
	dvrsbFS:SetText("Right Side Action Bars");
	dvrsbFS:SetTextColor(1, 1, 1);
	
	local t=dvrsbframe:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(dvrsbframe)
	t:SetColorTexture(0, 192, 255, 0.7)
	
local mbarspagenumber=CreateFrame("Frame", "MBarsPageNumber", dvlockcheckframe)
	mbarspagenumber:SetClampedToScreen(1)
	mbarspagenumber:SetFrameStrata(HIGH)
	mbarspagenumber:SetPoint("BOTTOM", mbars, "BOTTOM")
	mbarspagenumber:SetSize(10,36)

local function move(frame,anchorPoint,relativeTo,relativePoint,xoff,yoff)
	frame:ClearAllPoints()
	frame:SetPoint(anchorPoint,relativeTo,relativePoint,xoff,yoff)
end

-- Position anchor buttons for each bar
	move(ActionButton1,"BOTTOMLEFT",mbars,"BOTTOMLEFT",0,0)
	move(MultiBarBottomLeftButton1,"BOTTOMLEFT",ActionButton1,"TOPLEFT",0,6)
	move(MultiBarBottomRightButton1,"BOTTOMLEFT",MultiBarBottomLeftButton1,"TOPLEFT",0,6)
	move(MultiBarRightButton12,"BOTTOMRIGHT", dvrsbframe, "BOTTOMRIGHT", 0, 0)
	move(MultiBarLeftButton12,"BOTTOMRIGHT", MultiBarRightButton4, "BOTTOMLEFT", 0, 0)
	move(PetActionButton1,"BOTTOMLEFT", dvpetframe, "BOTTOMLEFT", 0, 0)
	move(StanceButton1,"BOTTOMLEFT", dvstanceframe, "BOTTOMLEFT", 0, 0)

-- Anchor buttons 2-12 for each bar
	for _,bar in pairs({"ActionButton","MultiBarBottomLeftButton","MultiBarBottomRightButton"}) do
		for i=1,12 do
			v =_G[bar..i]
		end
		for i=2,12 do
			move(_G[bar..i],"LEFT",_G[bar..(i-1)],"RIGHT",4,0)
		end
	end

-- Anchor buttons for right side bars
	for _,bar in pairs({"MultiBarRightButton","MultiBarLeftButton"}) do
		for i=1,12 do
			v =_G[bar..i]
			v:SetScale(0.84)
			v:SetFrameStrata("BACKGROUND")

		end
		for i=11,9, -1 do
			move(_G[bar..i],"BOTTOM",_G[bar..(i+1)],"TOP",0,0)
		end
		for i=8,5, -1 do
			move(_G[bar..i],"BOTTOM",_G[bar..(i+1)],"TOP",0,0)
		end
		for i=4,1, -1 do
			move(_G[bar..i],"BOTTOM",_G[bar..(i+1)],"TOP",0,0)
		end
		for i=8,4, -4 do
			move(_G[bar..i],"RIGHT",_G[bar..(i+4)],"LEFT",0,0)
		end
	end

-- Anchor buttons 2-10 for Pet Action bar
	for _,bar in pairs({"PetActionButton"}) do
		for i=2,10 do
			move(_G[bar..i],"LEFT",_G[bar..(i-1)],"RIGHT",2,0)
		end
	end
	
-- Anchor buttons 2-10 for Stance bar
	for _,bar in pairs({"StanceButton"}) do
		for i=2,10 do
			move(_G[bar..i],"LEFT",_G[bar..(i-1)],"RIGHT",2,0)
		end
	end
	
-- Action Bar Up/Down buttons
	move(MainMenuBarPageNumber,"CENTER",mbars,"CENTER",0,0)
	ActionBarUpButton:Hide()
	ActionBarDownButton:Hide()
	
-- DVMicroMenuFrame
local dvmmframe=CreateFrame("Frame", "dvmmframe", dvlockcheckframe)
	dvmmframe:RegisterEvent("PLAYER_LOGIN")
	dvmmframe:RegisterEvent("PLAYER_REGEN_ENABLED")
	dvmmframe:RegisterEvent("PLAYER_REGEN_DISABLED")
	dvmmframe:RegisterEvent("CINEMATIC_START")
	dvmmframe:RegisterEvent("CINEMATIC_STOP")
	dvmmframe:RegisterEvent("PET_BATTLE_OVER")
	dvmmframe:SetFrameStrata("HIGH")
	dvmmframe:SetClampedToScreen(true)
	dvmmframe:SetMovable(true)
	dvmmframe:EnableMouse(true)
	dvmmframe:RegisterForDrag("LeftButton")
	dvmmframe:SetWidth(310)
	dvmmframe:SetHeight(36)
	dvmmframe:Show()
	
	dvmmframe:SetScript("OnEvent", function(self, event, arg1)
		if event == "PET_BATTLE_OVER" then
			CharacterMicroButton:ClearAllPoints()
			CharacterMicroButton:SetPoint("BOTTOMLEFT",dvmmframe,"BOTTOMLEFT",27,-1)			
		else
			local point = private.db.micromenuSetPoints
			self:ClearAllPoints()		
			self:SetPoint(
			point.point, 
			point.relativeTo, 
			point.relativePoint, 
			point.xOffset, 
			point.yOffset)
			CharacterMicroButton:ClearAllPoints()
			CharacterMicroButton:SetPoint("BOTTOMLEFT",dvmmframe,"BOTTOMLEFT",27,-1)
		end
	end)

	dvmmframe:SetScript("OnDragStart", dvmmframe.StartMoving) 
	
	dvmmframe:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing() 
		self:SetUserPlaced(false) 
		
		point, relativeTo, relativePoint, xOfs, yOfs = self:GetPoint(1)
			if ( relativeTo ) then
				relativeTo = relativeTo:GetName();
			else
				relativeTo = self:GetParent():GetName();
			end
	
		-- These are debugging messages for the frame points
		-- Un-comment them to help debug
		-- DEFAULT_CHAT_FRAME:AddMessage(point)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativeTo)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativePoint)
		-- DEFAULT_CHAT_FRAME:AddMessage(xOfs)
		-- DEFAULT_CHAT_FRAME:AddMessage(yOfs)
		
		private.db.micromenuSetPoints.point = point
		private.db.micromenuSetPoints.relativeTo = relativeTo
		private.db.micromenuSetPoints.relativePoint = relativePoint
		private.db.micromenuSetPoints.xOffset = xOfs
		private.db.micromenuSetPoints.yOffset = yOfs		
	end)
	
local dvmmframeFS = dvmmframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local dvmmFS = dvmmframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	dvmmFS:SetPoint("CENTER",dvmmframe,"CENTER",0,0)
	dvmmFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
	dvmmFS:SetText("Micro Menu Buttons");
	dvmmFS:SetTextColor(1, 1, 1);

	local t=dvmmframe:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(dvmmframe)
	t:SetColorTexture(0, 192, 255, 0.7)
	
-- Micro Buttons Mouse Fade
local ignoreMMBalpha
local DVMMBAlphaTimer

local function SetAlpha(frame)
	if ignoreMMBalpha then return end
	ignoreMMBalpha = true
	if frame:IsMouseOver() then
		frame:SetAlpha(1)
	else
		frame:SetAlpha(0)
	end
	ignoreMMBalpha = nil
end

local function showMMB(self)
	if DVMMBAlphaTimer then DVMMBAlphaTimer:Cancel() end
    for _, v in ipairs(MICRO_BUTTONS) do
        ignoreMMBalpha = true
        _G[v]:SetAlpha(1)
        ignoreMMBalpha = nil
    end
end
 
local function hideMMB(self)
    for _, v in ipairs(MICRO_BUTTONS) do
        ignoreMMBalpha = true
        _G[v]:SetAlpha(0)
        ignoreMMBalpha = nil
    end
end

local function delayHideMMB(self)
	DVMMBAlphaTimer = C_Timer.NewTimer(0.75, hideMMB)
end

for _, v in ipairs(MICRO_BUTTONS) do
    v = _G[v]
    hooksecurefunc(v, "SetAlpha", SetAlpha)
    v:HookScript("OnEnter", showMMB)
    v:HookScript("OnLeave", delayHideMMB)
    v:SetAlpha(0)
end

-- XP/Rep Bar
	MainMenuExpBar:SetSize(476,6)
	MainMenuBarMaxLevelBar:SetSize(476,6)
	ReputationWatchBar.StatusBar:SetAllPoints(ReputationWatchBar)
	ArtifactWatchBar.StatusBar:SetAllPoints(ArtifactWatchBar)


-- Move XP Bar Anchor
	move(MainMenuExpBar,"BOTTOMLEFT",ActionButton1,"TOPLEFT",0,0)
	move(MainMenuBarMaxLevelBar,"BOTTOMLEFT",ActionButton1,"TOPLEFT",0,0)

local maxlevel = GetMaxPlayerLevel()	
local level = UnitLevel("player")

-- SetPoint expects (self,anchorPoint,relativeTo,relativePoint,xoff,yoff)
-- to prevent this hook calling itself, we attach a custom flag at the end
-- so it knows when not to react to the SetPoint.
	hooksecurefunc(ReputationWatchBar,"SetPoint",function(self,_,_,_,_,_,flag)
		if flag~="mbars" then
			self:ClearAllPoints()
					self:SetPoint("BOTTOMLEFT",MultiBarBottomLeftButton1,"TOPLEFT",0,0,"mbars")
					self:SetSize(476,6)
		end
	end)
	
	hooksecurefunc(ArtifactWatchBar,"SetPoint",function(self,_,_,_,_,_,flag)
		if flag~="mbars" then
			self:ClearAllPoints()
				if level==maxlevel then
					self:SetPoint("BOTTOMLEFT",ActionButton1,"TOPLEFT",0,0,"mbars")
					self:SetSize(476,6)
				else
					self:SetPoint("BOTTOMLEFT",MultiBarBottomLeftButton1,"TOPLEFT",0,0,"mbars")
					self:SetSize(476,6)
				end
		end
	end)
	
-- DV Bag Buttons Mouseover Fade
local dvbagframe=CreateFrame("Frame", "dvbagframe", dvlockcheckframe)
	dvbagframe:RegisterEvent("PLAYER_LOGIN")
	dvbagframe:SetFrameStrata("HIGH")
	dvbagframe:SetClampedToScreen(true)
	dvbagframe:SetMovable(true)
	dvbagframe:EnableMouse(true)
	dvbagframe:RegisterForDrag("LeftButton")
	dvbagframe:SetWidth(160)
	dvbagframe:SetHeight(45)
	dvbagframe:Show()

	dvbagframe:SetScript("OnEvent", function(self, event, arg1)
		if event == "PLAYER_LOGIN" then
		local point = private.db.bagsSetPoints
			self:ClearAllPoints()		
			self:SetPoint(
				point.point, 
				point.relativeTo, 
				point.relativePoint, 
				point.xOffset, 
				point.yOffset)
		end
	end)
	
	dvbagframe:SetScript("OnDragStart", dvbagframe.StartMoving) 
	
	dvbagframe:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing() 
		self:SetUserPlaced(false) 
		
		point, relativeTo, relativePoint, xOfs, yOfs = self:GetPoint(1)
			if ( relativeTo ) then
				relativeTo = relativeTo:GetName();
			else
				relativeTo = self:GetParent():GetName();
			end
	
		-- These are debugging messages for the frame points
		-- Un-comment them to help debug
		-- DEFAULT_CHAT_FRAME:AddMessage(point)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativeTo)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativePoint)
		-- DEFAULT_CHAT_FRAME:AddMessage(xOfs)
		-- DEFAULT_CHAT_FRAME:AddMessage(yOfs)
		
		private.db.bagsSetPoints.point = point
		private.db.bagsSetPoints.relativeTo = relativeTo
		private.db.bagsSetPoints.relativePoint = relativePoint
		private.db.bagsSetPoints.xOffset = xOfs
		private.db.bagsSetPoints.yOffset = yOfs		
	end)
	
local dvbagframeFS = dvbagframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local dvbagFS = dvbagframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	dvbagFS:SetPoint("CENTER",dvbagframe,"CENTER",0,0)
	dvbagFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
	dvbagFS:SetText("Bags");
	dvbagFS:SetTextColor(1, 1, 1);
	
local t=dvbagframe:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(dvbagframe)
	t:SetColorTexture(0, 192, 255, 0.7)

BAG_BUTTONS = {
	"MainMenuBarBackpackButton",
	"CharacterBag0Slot",
	"CharacterBag1Slot",
	"CharacterBag2Slot",
	"CharacterBag3Slot",
	}
local ignoreDVBBAalpha
local DVBBAlphaTimer

local function SetAlpha(frame)
	if ignoreDVBBAalpha then return end
	ignoreDVBBAalpha = true
	if frame:IsMouseOver() then
		frame:SetAlpha(1)
	else
		frame:SetAlpha(0)
	end
	ignoreDVBBAalpha = nil
end


local function showDVBB(self)
	if DVBBAlphaTimer then DVBBAlphaTimer:Cancel() end
	for _, v in ipairs(BAG_BUTTONS) do
		ignoreDVBBAalpha = true
		_G[v]:SetAlpha(1)
		ignoreDVBBAalpha = nil
	end
end

local function hideDVBB(self)
	for _, v in ipairs(BAG_BUTTONS) do
		ignoreDVBBAalpha = true
		_G[v]:SetAlpha(0)
		ignoreDVBBAalpha = nil
	end
end

local function delayHideDVBB(self)
	DVBBAlphaTimer = C_Timer.NewTimer(0.75, hideDVBB)
end

for _, v in ipairs(BAG_BUTTONS) do
    v = _G[v]
    hooksecurefunc(v, "SetAlpha", SetAlpha)
    v:HookScript("OnEnter", showDVBB)
    v:HookScript("OnLeave", delayHideDVBB)
    v:SetAlpha(0)
end

-- Bag Buttons Init
	MainMenuBarBackpackButton:ClearAllPoints()
	MainMenuBarBackpackButton:SetPoint(
		"BOTTOMRIGHT", dvbagframe, "BOTTOMRIGHT", 0, 0)

 local _, private = ...
	private.defaults.stancebarSetChecked = {
		SetChecked = false,
	}	

local dvstancecheck = CreateFrame("CheckButton", "DejaViewStanceCheck", DejaViewPanel, "InterfaceOptionsCheckButtonTemplate")
	dvstancecheck:RegisterEvent("PLAYER_LOGIN")
	dvstancecheck:ClearAllPoints()
	dvstancecheck:SetPoint("TOPLEFT", 25, -100)
	dvstancecheck:SetScale(1.25)
	dvstancecheck.tooltipText = 'When checked hides the class stance/stealth bar.' --Creates a tooltip on mouseover.
	_G[dvstancecheck:GetName() .. "Text"]:SetText("Hide Stance Bar")

	dvstancecheck:SetScript("OnEvent", function(self, event, arg1)
		if event == "PLAYER_LOGIN" then
		local checked = private.db.stancebarSetChecked
			self:SetChecked(checked.SetChecked)
			if self:GetChecked(true) then
				dvstanceframe:SetClampedToScreen(false)
				move(dvstanceframe,"TOP", dvlockcheckframe, "BOTTOM", 0, -200)
				private.db.stancebarSetChecked.SetChecked = true
			else
				dvstanceframe:SetClampedToScreen(true)
				local point = private.db.stanceSetPoints
					dvstanceframe:ClearAllPoints()		
					dvstanceframe:SetPoint(
						point.point, 
						point.relativeTo, 
						point.relativePoint, 
						point.xOffset, 
						point.yOffset)
				private.db.stancebarSetChecked.SetChecked = false
			end
		end
	end)
	
	dvstancecheck:SetScript("OnClick", function(self,event,arg1) 
		if self:GetChecked(true) then
			dvstanceframe:SetClampedToScreen(false)
			move(dvstanceframe,"TOP", dvlockcheckframe, "BOTTOM", 0, -200)
			private.db.stancebarSetChecked.SetChecked = true
		else
			dvstanceframe:SetClampedToScreen(true)
			local point = private.db.stanceSetPoints
				dvstanceframe:ClearAllPoints()		
				dvstanceframe:SetPoint(
					point.point, 
					point.relativeTo, 
					point.relativePoint, 
					point.xOffset, 
					point.yOffset)
				private.db.stancebarSetChecked.SetChecked = false
		end
	end)