 local _, private = ...
	private.defaults.bottomtextureSetChecked = {
		SetChecked = false,
	}	
	
local dvbottomtexturecheck = CreateFrame("CheckButton", "DejaViewBottomTextureCheck", DejaViewPanel, "InterfaceOptionsCheckButtonTemplate")
	dvbottomtexturecheck:RegisterEvent("PLAYER_LOGIN")
	dvbottomtexturecheck:ClearAllPoints()
	dvbottomtexturecheck:SetPoint("TOPLEFT", 25, -75)
	dvbottomtexturecheck:SetScale(1.25)
	dvbottomtexturecheck.tooltipText = 'When checked disables display of the semi transparent bottom texture.' --Creates a tooltip on mouseover.
	_G[dvbottomtexturecheck:GetName() .. "Text"]:SetText("Hide Bottom Texture")
	
-- DVBottom Texture

local dbtexture=CreateFrame("Frame", "dbtexture", UIParent)
	dbtexture:SetClampedToScreen(1)
	dbtexture:SetFrameStrata("BACKGROUND")
	dbtexture:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT")
	dbtexture:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT")
	dbtexture:SetHeight(121)

local t=dbtexture:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(dbtexture)
	t:SetColorTexture(0, 0, 0, 0.60)
	
	dvbottomtexturecheck:SetScript("OnEvent", function(self, event, arg1)
		if event == "PLAYER_LOGIN" then
		local checked = private.db.bottomtextureSetChecked
			self:SetChecked(checked.SetChecked)
			if self:GetChecked(true) then
				dbtexture:Hide()
				private.db.bottomtextureSetChecked.SetChecked = true
			else
				dbtexture:Show()				
				private.db.bottomtextureSetChecked.SetChecked = false
			end
		end
	end)

	dvbottomtexturecheck:SetScript("OnClick", function(self,event,arg1) 
		if self:GetChecked(true) then
			dbtexture:Hide()
			private.db.bottomtextureSetChecked.SetChecked = true
		else
			dbtexture:Show()
			private.db.bottomtextureSetChecked.SetChecked = false
		end
	end)